const api = require('./src/index')()
const run = async() => {
  const bucket = api.bucket({
    slug: 'next-merge-live-staging',
    read_key: 'crvax6wakPEGYgY3RBoAnVs1pgMJDx3hvORx3isg7KaOIy3jC7' //crvax6wakPEGYgY3RBoAnVs1pgMJDx3hvORx3isg7KaOIy3jC7'
  })
  // async / await way
  try {
    const res = await bucket.objects.find({
      type: "posts"
    })
    .props('id,slug,title,metadata.cover_image.url')
    .limit(1)
    console.log('try',res)
  } catch (err) {
    console.log('catch',err)
  }

  try {
    const res = await bucket.objects.findOne({
      id: '616dd35e60113a0009fdca51'
    })
    .props('id,slug,title,metadata.cover_image.url')
    .limit(1)
    console.log('try',res)
  } catch (err) {
    console.log('catch',err)
  }

  // // Promise way
  // bucket.objects.find({
  //   type: "posts"
  // })
  // .props('id,slug,title,metadata.cover_image.url')
  // .limit(1)
  // .then((res, err) => {
  //   console.log('res', res)
  //   console.log('err', err)
  // })

  // // Old way
  // bucket.getObjects({
  //   query: {
  //     type: "posts"
  //   },
  //   props: 'slug,title,metadata.cover_image.url',
  //   limit: 1
  // }).then((data) => {
  //   console.log('data',data)
  // }).catch((err) => {
  //   console.log('catch',err)
  // })

  // Media
  // try {
  //   const res = await bucket.media.find()
  //   .props('url')
  //   .limit(1)
  //   console.log('try',res)
  // } catch (err) {
  //   console.log('catch',err)
  // }
  // // Promise way
  // bucket.media.find()
  // .props('url')
  // .limit(1)
  // .then((res, err) => {
  //   console.log('res', res)
  //   console.log('err', err)
  // })
}
run();
